"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ifElse = exports.left = exports.right = void 0;
var react_1 = __importDefault(require("fast-deep-equal/es6/react"));
var adt_builder_1 = require("../utils/adt-builder");
var serializer_1 = require("../utils/serializer");
var builder = adt_builder_1.createAdtBuilder({});
var right = function (value) {
    return builder.flatten(value).seal(function (data) { return (__assign(__assign({}, serializer_1.createSerializer('right', data)), { isLeft: false, isRight: true, equals: function (operand) {
            return operand.fold(function () { return false; }, function (it) { return react_1.default(it, data); });
        }, fold: function (_, ifRight) { return (ifRight ? ifRight(data) : data); }, map: function (ifRight) { return exports.right(ifRight(data)); }, mapIf: function (predicate, ifTrue) { return (predicate(data) ? exports.right(ifTrue(data)) : exports.right(data)); }, mapLeft: function () { return exports.right(data); }, orElse: function () { return exports.right(data); } })); });
};
exports.right = right;
var left = function (value) {
    return builder.flatten(value).seal(function (data) { return (__assign(__assign({}, serializer_1.createSerializer('left', data)), { isLeft: true, isRight: false, equals: function (operand) {
            return operand.fold(function (it) { return react_1.default(it, data); }, function () { return false; });
        }, fold: function (ifLeft) { return (ifLeft ? ifLeft(data) : data); }, map: function () { return exports.left(data); }, mapIf: function () { return exports.left(data); }, mapLeft: function (ifLeft) { return exports.left(ifLeft(data)); }, orElse: function (ifLeft) { return exports.right(ifLeft(data)); } })); });
};
exports.left = left;
var ifElse = function (bool, ifFalse, ifTrue) { return (bool ? exports.right(ifTrue()) : exports.left(ifFalse())); };
exports.ifElse = ifElse;
//# sourceMappingURL=either.js.map