import { Just, JustValueOrMaybe, Maybe, None } from './maybe.types';
export declare const just: <A>(value: Just<A> | None<A> | NonNullable<A>) => Maybe<A>;
export declare const none: <A = [Error, "Please specify type in none"]>() => Maybe<A>;
export declare const maybe: <A>(value?: A | Just<A> | None<A> | null | undefined) => Maybe<A>;
