import { Either, LeftValueOrEither, RightValueOrEither } from './either.types';
export declare const right: <E = [Error, "Please specify E type in right<E, A>"], A = [Error, "Please specify A type in right<E, A>"]>(value: RightValueOrEither<A>) => Either<E, A>;
export declare const left: <E = [Error, "Please specify E type in left<E, A>"], A = [Error, "Please specify A type in left<E, A>"]>(value: LeftValueOrEither<E>) => Either<E, A>;
export declare const ifElse: <E, A>(bool: boolean, ifFalse: () => LeftValueOrEither<E>, ifTrue: () => RightValueOrEither<A>) => Either<E, A>;
