/// <reference types="jest" />
declare global {
    namespace jest {
        interface Matchers<R> {
            toBeRight(expected: any): CustomMatcherResult;
            toBeLeft(expected: any): CustomMatcherResult;
            toBeJust(expected: NonNullable<any>): CustomMatcherResult;
            toBeNone(): CustomMatcherResult;
            toHaveBeenLastCalledWithRight(expected: any): CustomMatcherResult;
            toHaveBeenLastCalledWithLeft(expected: any): CustomMatcherResult;
            toHaveBeenLastCalledWithJust(expected: any): CustomMatcherResult;
            toHaveBeenLastCalledWithNone(): CustomMatcherResult;
        }
    }
}
export {};
